#ifndef QUARK_DEVICEQUEUE_H
#define QUARK_DEVICEQUEUE_H

#include <sys/types.h>

/*
 *  The Queue to Store Data From A Raw Character Device
 * 		( Example : Keyboard , Network Card , Mouse )
 */

#define QUEUE_SIZE	1024
#define PREFETCH_SIZE	512	//(QUEUE_SIZE/2)

class DeviceQueue
{
private:
	// Volatile Coz Queue May Be Modified @ any time by Handler_KeyboardIRQ
	// So it is safer to read the mem locations than register values
	// of size,front,rear variables
	volatile byte data[1024];
	volatile uint front,rear;
	volatile uint size;
public:
	DeviceQueue();
	volatile void addRawData(byte);
	volatile byte getRawData();
	volatile inline int empty();
	volatile inline int full();
};

#endif
