#ifndef QUARK_KEYBOARD_H
#define QUARK_KEYBOARD_H

#include <kernel/Console.h>
#include <kernel/IDT.h>
#include <kernel/PIC.h>

// Key Defenitions

#define LED_SCROLL_LOCK	0x01
#define LED_NUM_LOCK	0x02
#define LED_CAPS_LOCK	0x04

#define CK_SHIFT	0x01
#define CK_ALT		0x02
#define CK_CTRL		0x04

#define SCROLL_LOCK	0x46
#define NUM_LOCK	0x45
#define CAPS_LOCK	0x3A

#define KEYB_CTRL               0x64
#define KEYB_PORT               0x60
#define KEYB_SET_LEDS           0xED
#define KEYB_TYPEMATIC          0xFA
#define KEYB_TYPEMATIC_MODE     0xF3
#define KEYB_REBOOT             0xFE

#define KBD_OBUF_FULL           0x1
#define KBD_IBUF_FULL           0x02
#define KBD_CMD_WOUT            0xd1
#define KBD_A20                 0xdf


// End Of Key Defenitions


extern Console * activeConsole;

/*
 *	Device Driver Abstaction Of the Keyboard
 *	TODO: 	Write a common Character Device Base Class
 *		Derive Keyboard,EthernetCard etc from the Char class
 */
class Keyboard
{
private:
	static void updateLED(byte);
	static int isUsefulKey(byte);
public:
	Keyboard();
	void initialize(PIC * pic,IDT * idt);
	friend int Handler_KeyboardIRQ();
};

int Handler_KeyboardIRQ();

#endif
