#ifndef QUARK_IDT_H
#define QUARK_IDT_H

#include <sys/types.h>
#include <kernel/Exceptions.h>

#define CS_SELECTOR 0x08

#define IDT_BASE 0x6800
#define IDT_LOW  0x6800
#define IDT_HIGH 0x0000

#define INTR_GATE 0x06
#define TRAP_GATE 0x07

#define BITS16 0x00
#define BITS32 0x08

#define ABSENT  0x00
#define PRESENT 0x80

#define RING0 0x00
#define RING1 0x20
#define RING2 0x40
#define RING3 0x60

typedef struct IDT_tag
{
	unsigned short int lowerOffset;
	unsigned short int selector;
	byte reserved;
	byte options;
	unsigned short int upperOffset;
}InterruptDescriptorTable;

typedef struct IDTR_tag
{
	unsigned short int limit;
	unsigned short int low;
	unsigned short int high;
}IDTRegister;

/*
 *	Important abstraction of the protected mode Interrupt Descriptor Table
 */
class IDT
{
private:
	void loadIDTRegister(IDTRegister *);
public:
	IDT();
	void initialize();
	void createEntry(int,uint,ushort,byte);
};

#endif
