#ifndef QUARK_PIC_H
#define QUARK_PIC_H

#include <sys/types.h>

#define MASTER_PORT_A 0x20
#define MASTER_PORT_B 0x21
#define SLAVE_PORT_A  0xA0
#define SLAVE_PORT_B  0xA1

#define TIMER		0x00
#define KEYBOARD	0x01
#define SLAVE		0x02
#define TTY1		0x03
#define TTY2		0x04
#define XT_HDD		0x05
#define FLOPPY		0x06
#define PRINTER		0x07
#define REALTIMECLOCK	0x08
#define PS2MOUSE	0x0C

#define FPU_EXCEPTION	0x13
#define AT_HDD		0x14

/*
 *	The Programmable Interrupt Controller 8259a functionality
 */
class PIC
{
private:
	byte IRQMasterStatus,IRQSlaveStatus;
public:
	PIC();

	void initialize();

	void enableIRQ(byte);
	void disableIRQ(byte);
};

#endif
