/* The Quark VGA driver is derived from many linux source files */

#ifndef QUARK_VGA_H
#define QUARK_VGA_H

#include <sys/types.h>

#define HEIGHT 50

#define NUM_CRTC_REGS	25
#define NUM_AC_REGS	21
#define NUM_GC_REGS	9
#define NUM_SEQ_REGS	5
#define NUM_OTHER_REGS	1
#define NUM_REGS	( NUM_CRTC_REGS + NUM_AC_REGS + NUM_GC_REGS +   \
				+ NUM_SEQ_REGS + NUM_OTHER_REGS)


/*
 *	Copied Faithfully From Linux Source Code
 */
#define VGA_AC_INDEX		0x3C0
#define VGA_AC_WRITE		0x3C0
#define VGA_AC_READ		0x3C1
#define VGA_MISC_WRITE		0x3C2
#define VGA_SEQ_INDEX		0x3C4
#define VGA_SEQ_DATA		0x3C5
#define VGA_DAC_READ_INDEX	0x3C7
#define VGA_DAC_WRITE_INDEX	0x3C8
#define VGA_DAC_DATA		0x3C9
#define VGA_MISC_READ		0x3CC
#define VGA_GC_INDEX		0x3CE
#define VGA_GC_DATA		0x3CF
#define VGA_CRTC_INDEX		0x3D4
#define VGA_CRTC_DATA		0x3D5
#define VGA_INSTAT_READ		0x3DA

typedef struct vga_font_tag
{
	ushort first,last;
	uchar height;
	uchar * bitmaps;
}FontDescriptor;

/*
 *	Front end for the VGA Controller
 */
class VGA
{
private:
	uint height;
	uint width;
	void outsw (ushort, ushort*, uint   );
	void poke  (ulong , ushort , ushort );
	void pokeb (ulong , ushort , uchar  );
	void write ( uchar * );
	void setFont ( FontDescriptor * );
	void clearscreen();
public:
	VGA();
	void initialize(byte,byte);

	inline uint getWidth()  { return height; }
	inline uint getHeight() { return width;  }

};

#endif
