#include <debug/Debug.h>
#include <kernel/Kernel.h>

Debug::Debug(uint displayRow,byte attr)
{
	ulong flags = 0;
	saveFlags(flags);
	disableInterrupts();

	this->attr = attr;
	vgamem = (uchar *)0xB8000+(displayRow*160);
	for(int i=0;i<160;i+=2)
	{
		vgamem[i]   = ' ';
		vgamem[i+1] = this->attr;
	}

	restoreFlags(flags);
}

void Debug::write(char * str)
{
	ulong flags = 0;
	saveFlags(flags);
	disableInterrupts();

	int i = 0;
	while(*str)
	{
		if(i >= 160) break;
		vgamem[i++] = *str++;
		vgamem[i++] = this->attr;
	}
	while(i<160)
	{
		vgamem[i++] = ' ';
		vgamem[i++] = this->attr;
	}

	restoreFlags(flags);
}
