#include <kernel/IDT.h>

IDT::IDT()
{

}

void IDT::initialize()
{
	extern Exception exceptions[32];
	IDTRegister idtReg;

	for(int i=0;i<32;i++)
	{
		createEntry(
				exceptions[i].id,
				(uint)exceptions[i].hook,
				CS_SELECTOR,
				TRAP_GATE|PRESENT|RING0|BITS32
			   );
	}
	
	idtReg.limit 	= (ushort) 0x110;
	idtReg.low 	= (ushort) IDT_LOW;
	idtReg.high 	= (ushort) IDT_HIGH;

	loadIDTRegister(&idtReg);
}

void IDT::createEntry(int n,uint offset,ushort selector,byte options)
{
	InterruptDescriptorTable *idt=(InterruptDescriptorTable*) IDT_BASE + n;
	ushort lOff,uOff;
	
	lOff = offset & 0x0000FFFF;		// Clear First 16 bits
	uOff = (offset & 0xFFFF0000) >> 16;	// Clear Lower 16 bits

	idt->lowerOffset = lOff;
	idt->selector = selector;
	idt->reserved = 0x00;
	idt->options = options;
	idt->upperOffset = uOff;
}

void IDT::loadIDTRegister(IDTRegister * idtr)
{
	asm("lidt (%0) ": :"p"(idtr));
}
