#include <asm/io.h>

void outb ( word port , byte data )
{
	__asm__ ( "outb %%al,%%dx": :"a"(data),"d"(port) );
}

void outw ( word port , word data )
{
	__asm__ ( "outw %%ax,%%dx": :"a"(data),"d"(port) );
}

void outd ( word port , dword data )
{
	__asm__ ("outl %%eax,%%dx": :"a"(data),"d"(port) );
}

byte inb ( word port)
{
	byte value;
	__asm__ ("inb %%dx,%%al": "=a"(value) :"d"(port ));
	return value;
}

word inw ( word port)
{
	word value;
	__asm__ ("inw %%dx,%%ax": "=a"(value) :"d"(port));
	return value;
}

dword ind ( word port)
{
	dword value;
	__asm__ ("inl %%dx,%%eax": "=a"(value) :"d"(port));
	return value;
}

void MoveCursor(byte r , byte c)
{
	word pos = (80*r)+c;
	byte lsb = (byte) (pos & 0x00FF);
	byte msb = (byte) ((pos & 0xFF00) >> 0x08);
	
	outb(0x03D4,0x0F);	// Make VGA Controller Ready For LS Byte
	outb(0x03D5,lsb);	// Send LSB

	outb(0x03D4,0x0E);	// Make VGA Controller Ready For MS Byte
	outb(0x03D5,msb); 	// Send MSB
}
