#include <shell/Shell.h>
#include <lib/string.h>
#include <lib/ctype.h>
#include <lib/stdio.h>
#include <kernel/Shutdown.h>
#include <kernel/Time.h>
#include <kernel/PIT.h>

#define BUFSIZE 512
char buf[BUFSIZE];

Shell::Shell()
{
	activeConsole->cls();
	initTimeArea();
}

void Shell::execute()
{
	uint len;
	
	activeDebug->write("Enter your login ID");
	activeConsole->write("Login : ");
	
	resetBuffer();
	gets(buf,BUFSIZE,1);
	
	len = strlen(buf);
	if(len <= 1) return;
	if(buf[len-1] == '\n' || buf[len-1] == '\r')
		buf[len-1] = '\0';
	
	activeConsole->write("\nWelcome to the Quark OS Shell , ");
	activeConsole->write(buf);
	activeConsole->write(" !\n");

	while(1)
	{
		activeConsole->write("\nQuark OS > ");
		activeDebug->write("Quark OS by Ananth Shrinivas");
		resetBuffer();
		gets(buf,BUFSIZE,1);
		
		len = strlen(buf);
		if(len <= 1) continue;

		if(buf[len-1] == '\n' || buf[len-1] == '\r')
			buf[len-1] = '\0';

		if(!strcmp(buf,"exit")) return;
		executeCommand();
	}
}

void Shell::resetBuffer()
{
	memcpy(buf,0x00,BUFSIZE);
}

void Shell::executeCommand()
{
	if(!strcmp(buf,"cls"))
	{
		activeConsole->cls();
	}
	else if(!strcmp(buf,"help"))
	{
		activeConsole->write("\nQuark OS Shell\n");
		activeConsole->write(    "==============\n");
		activeConsole->write("\nCommands Available:\n");
		activeConsole->write("\n1) cls    : Clears the console\n");
		activeConsole->write("\n2) help   : Display this help\n");
		activeConsole->write("\n3) date   : Show Time and Date\n");
		activeConsole->write("\n4) reboot : Reboot Quark OS\n");
		activeConsole->write("\n5) exit   : Terminate session\n");

	activeConsole->write("\nINTERNAL DEBUGGING / TESTING COMMANDS\n");
	activeConsole->write("\nzero : RAISE ZERO DIVIDE ERROR INTERRUPT \n");
	activeConsole->write("\ntrap : RAISE SINGLE STEP TRAP INTERRUPT\n");

	}
	else if(!strcmp(buf,"reboot"))
	{
		kernelReboot();
	}
	else if(!strcmp(buf,"date"))
	{
		char buf[30];
		time_t t = {0,0,0,0,0,0,0};
		time(&t);
		asctime(buf,&t);
		activeConsole->write(buf);
	}

	else if(!strcmp(buf,"zero"))
	{
		int x = 0;
		int y = 0;
		x = x/y;
	}
	else if(!strcmp(buf,"trap"))
	{
		__asm__("int $1");
	}

	else
	{
		activeConsole->write
			("Oops ! You entered an invalid command.");
	}
}
