#include <drivers/Keyboard.h>
#include <kernel/Delay.h>
#include <debug/Debug.h>
#include <asm/io.h>

extern Debug * activeDebug;

void kernelShutdown()
{
	asm("cli");
	asm("hlt");
}

void kernelReboot()
{
_TryAgain:
	activeDebug->write("Rebooting Quark OS Now !!");
	delay(100);
	while ( inb(KEYB_CTRL) & 0x02 );
	outb(KEYB_CTRL,KEYB_REBOOT);
	activeDebug->write("Reboot failed trying again ....");
	delay(100);
	goto _TryAgain;
}

void kernelPanic()
{
	asm("cli");
	asm("hlt");
}
