#include <kernel/Time.h>
#include <lib/stdio.h>
#include <lib/string.h>
#include <kernel/Bios.h>

#define BASE_YEAR	2000

char  days[][4] = { "Mon","Tue","Wed","Thu","Fri","Sat","Sun" };
char  months[][4] ={ 
			"Jan","Feb","Mar","Apr","May","Jun",
			"Jul","Aug","Sep","Oct","Nov","Dec"
		   };

char locale[4] = "IST";

void time ( time_t * t)
{
	// THE ORDER OF THE VALUES READ IS IMPORTANT FOR ACCURACY
	// ( i.e Read year first and the second at last )
	if(t)
	{
		t->year = readBIOS(YEAR_MASK)+BASE_YEAR;
		t->month = readBIOS(MONTH_MASK);
		t->date = readBIOS(DATE_MASK);
		t->day = readBIOS(DAY_MASK);
		t->hour = readBIOS(HOUR_MASK);
		t->minute = readBIOS(MINUTE_MASK);
		t->second = readBIOS(SECOND_MASK);
	}
}

/*
 * TO CHANGE : Asctime assumes that a buf of length 28 char is atleast supplied
 * No bounds check is performed => buffer with length < 28 leads to errors.
 */
void asctime(char * buf,time_t * t)
{
	//Tue 03 May 1983 08:20:37 IST\0
	//0123456789012345678901234567 8
	//	   1	     2
	if(t && buf)
	{
		sprintf (
			buf,"%3s %02u %3s %04u %02u:%02u:%02u %3s",
			days[t->day-1],t->date,months[t->month-1],t->year,
			t->hour,t->minute,t->second,locale
			);
	}
}
