#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define UNKNOWN_CHAR '.'

int displayFile(int fd)
{
	char buf[16],output[80];
	unsigned int len=0,hexval=0x00,i;
	unsigned int done = 0;
	int fact = 0;
	if(fd < 0)
		return 0;
	printf("\n");
	while(!done)
	{
		memset(output,'.',80);
		memset(buf,0x00,16);

		len = read(fd,buf,16);

		if(len < 0)
		{
			printf("\thexdump : read error\n");
			break;
		}

		if(len<=0)done=1;
		
		sprintf(output," %08X",hexval);
		hexval = hexval + 0x100;

		memset(output+8,' ',70);
		
		for(i=0;i<len;i++)
			sprintf(output+11+3*i,"%02x ",(unsigned char)buf[i]);
		fact = (16-len)*3;
		memset(output+59 - fact,' ',16 + fact);
		
		for(i=0;i<len;i++)
			output[61+i] = isprint(buf[i])?buf[i]:UNKNOWN_CHAR;
		
		output[78] = '\n';
		output[79] = '\0';
		
		printf("%s",output);
	}
	return 1;
}


int main( int argc , char * argv[] )
{
	int i,fd;
	
	if(argc < 2)
		displayFile(0);
	else
	{
		for(i=1;i<argc;i++)
		{
			printf("%s : ",argv[i]);
			fd = open (argv[i],O_RDONLY);
			if(!displayFile(fd))
				printf("\t** Error: Unable to read file **\n");
			close(fd);
		}
	}

	return 0;
}

